import traceback,re,json,os,sys,datetime,threading
from pydantic import BaseModel
from fastapi import APIRouter, HTTPException
from utils.utils import sysapp
from utils import utils

router = APIRouter()

class Item(BaseModel):
    innerIp: str


def install_monitor_handler(item_in):
    try:     
        sysapp.info(f"input: {item_in}")
        innerIp = item_in.innerIp       
        sysapp.debug(f"serverIp: {innerIp}")
        
        local_path='/home/epm/git/auto_deploy/cicd/pythonDev/nodeExporterDeploy.sh'
        remote_path='/home/epm/nodeExporterDeploy.sh'
        utils.upload_file(local_path, remote_path, innerIp)
        cmd = f"sudo bash /home/epm/nodeExporterDeploy.sh -installPath /home/epm"
        utils.runCommand(cmd=cmd, host=innerIp)

        sysapp.info("install success")
        # rsp["status"] = "success"
        # rsp["config"] = output
    except Exception as e:
        sysapp.error(e)
        return {"error": str(e)}

@router.put("/epm/svr/installMonitor")
def installMonitor(item_in: Item):
    rsp={
            "success": True,
        }
    thread1 = threading.Thread(target=install_monitor_handler, args=(item_in,)) 
    thread1.start()
    return rsp